﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.01
@EndOfDesignText@
Sub Class_Globals
	Private xui As XUI
	Private clv1 As CustomListView
	Private lblTitle As B4XView
	Private pnlTitle As B4XView
	Private ExpandedHeight As Int = 440dip
	Private CollapsedHeight As Int = 60dip 'should match pnlTitle height
	Private pnlExpanded As B4XView
	Private openMenu As Int
	Private LV1 As ListView
	Private CLVModels As CustomListView
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Parent As B4XView)
	Parent.LoadLayout("1")
	For i = 1 To 20
		clv1.Add(CreateItem(Rnd(0xFF000000, 0xFFFFFFFF), "Item #" & i), "")
	Next
End Sub

Sub CreateItem(clr As Int, Title As String) As B4XView
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, clv1.AsView.Width, ExpandedHeight)
	p.LoadLayout("Item")
	p.SetLayoutAnimated(0, 0, 0, p.Width, CollapsedHeight)
	lblTitle.Text = Title
	pnlTitle.Color = clr
	pnlExpanded.Color = ShadeColor(clr)
	p.Tag = False 'collapsed
	Return p
End Sub

Sub ShadeColor(clr As Int) As Int
	Dim argb() As Int = GetARGB(clr)
	Dim factor As Float = 0.75
	Return xui.Color_RGB(argb(1) * factor, argb(2) * factor, argb(3) * factor)
End Sub

Sub GetARGB(Color As Int) As Int()
	Private res(4) As Int
	res(0) = Bit.UnsignedShiftRight(Bit.And(Color, 0xff000000), 24)
	res(1) = Bit.UnsignedShiftRight(Bit.And(Color, 0xff0000), 16)
	res(2) = Bit.UnsignedShiftRight(Bit.And(Color, 0xff00), 8)
	res(3) = Bit.And(Color, 0xff)
	Return res
End Sub

Sub ExpandItem (index As Int)
	clv1.ResizeItem(index, ExpandedHeight)
	clv1.GetPanel(index).Tag = True
	AnimatedArrow(index, 0, 180)
End Sub

Sub AnimatedArrow(index As Int, From As Int, ToDegree As Int)
	pnlTitle = clv1.GetPanel(index).GetView(0) 'pnlTitle is the first item
	Dim iv As B4XView = pnlTitle.GetView(1) 'ImageView1 is the second item
	iv.SetRotationAnimated(0, From)
	iv.SetRotationAnimated(clv1.AnimationDuration, ToDegree)
End Sub

Sub CollapseItem(index As Int)
	clv1.ResizeItem(index, CollapsedHeight)
	clv1.GetPanel(index).Tag = False
	AnimatedArrow(index, 180, 0)
End Sub

Sub clv1_ItemClick (Index As Int, Value As Object)
	Dim p As B4XView = clv1.GetPanel(Index)
	Log("Index-" & Index)
	Log("Value-" & Value)
	If p.Tag = True Then'Item is Open so lets Close it
		CollapseItem(Index)
		openMenu = -1
	Else ' item is closed so lets open it.
		If openMenu > -1 Then
			CollapseItem(openMenu)
		End If
		Dim row As Int = clv1.GetItemFromView(Sender)
		Dim pnl As B4XView = clv1.GetPanel(row)
		Dim MyCLV As B4XView = pnl.GetView(0)
		MyCLV.AddTextItem("Falcon","44")
		ExpandItem(Index)
		openMenu = Index
	End If
End Sub

Sub FindExapnded As Int 'ignore
	For i = 0 To clv1.GetSize - 1
		If clv1.GetPanel(i).Tag = True Then Return i
	Next
	Return -1
End Sub



Sub Button1_Click
	Log("Button Clicked Item = " & (FindExapnded+1))
End Sub

Sub LV1_MouseClicked (EventData As MouseEvent)
	
End Sub

Sub CLVModels_ItemClick (Index As Int, Value As Object)
	
End Sub